    % ----------------------------------------------------------------
    % function CalUniqueness
    % input:  I ................Input image
    %         labels............Segmented regions
    %         clusterNumber.....number of regions
    % output: Uniqueness.....Output Uniqueness Map
    % implementation of Uniqueness, see:
    % Cheng et al., Global contrast based salient region detection, CVPR 2011 
    % for details
    % ----------------------------------------------------------------

    function [ Uniqueness ] = CalUniqueness( I, labels, clusterNumber )

        RCMS=mat2gray(SaliencyRCMS(I,labels,clusterNumber+1,0.4));
        HC = mat2gray(SaliencyHC(I));
        Uniqueness=(RCMS+HC);
        
    end

